// PlayerTactics.cpp

// Implementacia funkcii bezprostredne suvisiacich s taktickou strankou hraca (napr. spravanie sa hraca v roznych situaciach)

#include "Player/PlayerTactics.h"
//#include "Player/Formation.h"
//#include "Common/Support/Debug.h"
#include "Common/Tasks.h"
//#include <string.h>

#include <string>
#include <fstream>

using namespace std;


#define max(x,y) ( ((x) > (y)) ? (x) : (y) )
#define min(x,y) ( ((x) > (y)) ? (y) : (x) )

#define FIELDWIDTH 104

// Premenna signalizujuca funkcii NeckSynchronizationWithVI, ze prisla nova VI a treba okamzite poslat prikaz TurnNeck na server
#define NEW_VI 1000
#define NAR_VIEW 1001
#define NOR_VIEW 1002
#define ALIG_NECK 1003

extern bool PassTesting;
extern bool DribbleTesting;

// Ohodnocovacia mapa
extern CEvaluatingPanesMap* ePanesMap;

// Zoznam informacii o hracoch, ktorych vidi hrac
extern CEvaluatingPlayerList* ePlayerList;

extern bool EvaluatingPanes;

// Konstruktor
PlayerTactics::PlayerTactics() : PlayerSkills("PlayerSkills", "PlayerKernel(PlayerSkills) module")
{
	scanBeforeKickOffAngle = 0;

	nCornerKickModeDuration = 0;
	nFreeKickModeDuration = 0;
	nIndFreeKickModeDuration = 0;
	nKickInModeDuration = 0;

	nLastDribblePointCalculationCycle = 0;

	letGoalieRest = false;

	lfDribbleX = world->me->pos.GetX();
	lfDribbleY = world->me->pos.GetY();

	LPT_LeaderUniform = -1;
	LPT_LastSendTime = -1;
	LPT_AttentionToSet = false;
	LPT_CurrentFormation = LPT_FR_LJON;
	// loptosi - mj
	LPT_AmILeader = false;
	LPT_LastChangeTime = -1;
	LPT_LastSendTime = 0;

// GP
//    m_cFormation.InitRawUnits( SIDE_LEFT, PlayerConfig.GetFormation(), PlayerConfig.GetDefUnit(), 
//		PlayerConfig.GetMidUnit(), PlayerConfig.GetForUnit() );

//	m_cFormation.InitRawUnits( SIDE_LEFT, FORMATION_343, UNIT_3_L, UNIT_4_OV, UNIT_3_OV  );
//	m_cFormation.InitRawUnits(SIDE_LEFT, -1, 16, 2, 17);
//	m_cFormation.SetUnitOffset(-30.0f);
	FILE *f;
	char def, mid, atk, offset;
	float offset2;

	if ((f = fopen("formation.cfg", "r")) != NULL)
	{
		if (4 != fscanf(f, "%c%c%c%c", &def, &mid, &atk, &offset))
		{
			TXT("Zly format configu formacii, pouzivam default QCRN\n\n");
			m_cFormation.SetUnits(16, 2, 17);
			m_cFormation.SetUnitOffset(-30.0);
			fclose(f);
		}
		else
		{
			TXT("Formacia nacitana: %c%c%c%c\n\n", def, mid, atk, offset);
			m_cFormation.SetUnits(def - 'A', mid - 'A', atk - 'A');
			offset2 = 2.0f*(offset-'A') - FIELDWIDTH/2.0f;
			m_cFormation.SetUnitOffset(offset2);
			fclose(f);
		}
	}
	else
	{
		TXT("Config formacii nenajdeny, pouzivam default QCRN\n\n");
		m_cFormation.SetUnits(16, 2, 17);	
		m_cFormation.SetUnitOffset(-30.0);
	}


	Main::GetInstance()->RegisterModule(this, TACTICS_TASK);

#ifdef PASS_TRAINING
	ff = NULL;
	chytilsom = false;
#endif
	m_PassNet = new FCNetwork(16*3, 45, 0.7, 1);
	m_PassNet->Inicialize();
	m_PassNet->LoadFrom("passvahy.txt");

}

// Destruktor
PlayerTactics::~PlayerTactics()
{
	#ifdef PASS_TRAINING 
		fclose(ff); 
	#endif 
		
	//fclose(LPT_LeaderFileOut);
	delete m_PassNet;
}

// Vrati tento takticky interfejs
Interface* PlayerTactics::GetInterface(int task) const
{
	if(task == TACTICS_TASK)
		return (TacticsInterface*) this;
	else
		return PlayerSkills::GetInterface(task);
}


// Vrati formaciu
int PlayerTactics::GetFormation(const char* formation)
{
	// Asi zbytocne, v triede formation sa hodnota -1 aj tak neosetruje. Predpokladam cisto informacny/debug vyznam
    if (strncmp(formation, "Formation622", 12) == 0)
       return FORMATION_622;
    else if (strncmp(formation, "Formation532", 12) == 0)
       return FORMATION_532;
    else if (strncmp(formation, "Formation523", 12) == 0)
       return FORMATION_523;
    else if (strncmp(formation, "Formation433", 12) == 0)
       return FORMATION_433;
    else if (strncmp(formation, "Formation343", 12) == 0)
       return FORMATION_343;
    else if (strncmp(formation, "Formation334", 12) == 0)
       return FORMATION_334;

   return -1;

}

//
int PlayerTactics::GetUnit(int PlayerCount, char type) // PlayerCount nepouzivany, zatial neodstranujeme
{
/*    if (PlayerCount == 2) 
        return UNIT_2_L;

    else if ((PlayerCount == 3) && (type == 'A'))
        return UNIT_3_L;
    else if ((PlayerCount == 3) && (type == 'B'))
        return UNIT_3_V;
    else if ((PlayerCount == 3) && (type == 'C'))
        return UNIT_3_OV;

    else if ((PlayerCount == 4) && (type == 'A'))
        return UNIT_4_L;
    else if ((PlayerCount == 4) && (type == 'B'))
        return UNIT_4_V;
    else if ((PlayerCount == 4) && (type == 'C'))
        return UNIT_4_OV;
    else if ((PlayerCount == 4) && (type == 'D'))
        return UNIT_4_S;

    else if ((PlayerCount == 5) && (type == 'A'))
        return UNIT_5_L;
    else if ((PlayerCount == 5) && (type == 'E'))
        return UNIT_5_23;
    else if ((PlayerCount == 5) && (type == 'F'))
        return UNIT_5_32;
    else if ((PlayerCount == 5) && (type == 'B'))
        return UNIT_5_V;
    else if ((PlayerCount == 5) && (type == 'C'))
        return UNIT_5_OV;

    else if ((PlayerCount == 6) && (type == 'A'))
        return UNIT_6_2L;
    else if ((PlayerCount == 6) && (type == 'B'))
        return UNIT_6_V;
    else if ((PlayerCount == 6) && (type == 'C'))
        return UNIT_6_OV;
	return -1*/

	return type - 'A';
}

// Spravanie hraca s loptou
void PlayerTactics::BehaveWithBall()
{
	// Hrac s loptou ma zapnutu synchronizaciu funkcii otacia krkom s VI
	world->me->bNeckSynchronization = true;

	// Pomocne premenne
	double lfTmpX, lfTmpY;
	Point myPosition = world->me->pos;

	Player* enemyGoalie = GetEnemyGoalie();

// Cas, ktory caka hrac s loptou pre nabiehanie si spoluhracov
#define WAIT_TIMEOUT 25
	
//	LOG - kazda akcia musi byt zachytena, aby bolo jasne, co kedy hrac robi
	ofstream log1("Spravanie hraca s loptou.txt", ios::app);
	
	// [CYKLUS] Hrac c. XY
	int nSimTime = world->state->GetSimTime();
	int nPlayerNumber = world->me->GetUniform();
	log1 << endl << "[" << nSimTime << "]" << " Hrac c." << nPlayerNumber << endl;
	
	// Jeden z nasich zahravacich modov. Niekto z timu by mal zahrat. Nie je to tento hrac, takze sa nepokusaj kopnut loptu,
	// driblovat, atd.
	
	// <ZAHRAVACI MOD> (ZASTAVENA HRA)
	if(ShouldKickIn())
	{
		// Preskumam okolie
		if(scanBeforeKickOffAngle <= 360)
		{
			ExamineSurroundings();
			return;
		}

		// Otocili sme sa okolo svojej osi, mali by sme mat cerstve vizualne informacie a blbych superovych hracoch,
		// ktori sa nepohybuju a hladame najvhodnejsieho spoluhraca, ktoremu nahrame.

		// <Rohovy kop>
		if(world->state->GetPlayMode() == PM_CornerKick_Our)
		{
			if(nCornerKickModeDuration++ < WAIT_TIMEOUT)
			{	
				if((nCornerKickModeDuration == 1) && (!world->me->IsLookingAt(Point(25, 0))))
				{
					world->me->bNeckSynchronization = false;
					TurnTo(Point(25, 0));
					return;
				}	
				else
				{
					return;
				}
			}
			
			StartPlayOnByPassToOurPlayer();
			return;
		}

		// <Volny kop>
		else if(world->state->GetPlayMode() == PM_FreeKick_Our)
		{
			if(nFreeKickModeDuration++ < WAIT_TIMEOUT)
			{	
				if((nFreeKickModeDuration == 1) && (!world->me->IsLookingAt(Point(52.5, 0))))
				{
					world->me->bNeckSynchronization = false;
					TurnTo(Point(52.5, 0));
					return;
				}	
				else
				{
					return;
				}
			}
			
			StartPlayOnByPassToOurPlayer();
			return;
		}

		// <Individualny volny kop>
		else if(world->state->GetPlayMode() == PM_IndFreeKick_Our)
		{
			if(nIndFreeKickModeDuration++ < WAIT_TIMEOUT)
			{	
				if((nIndFreeKickModeDuration == 1) && (!world->me->IsLookingAt(Point(52.5, 0))))
				{
					world->me->bNeckSynchronization = false;
					TurnTo(Point(52.5, 0));
					return;
				}	
				else
				{
					return;
				}
			}
			
			StartPlayOnByPassToOurPlayer();
			return;
		}

		// <Vhadzovanie>
		if(world->state->GetPlayMode() == PM_KickIn_Our)
		{
			Point tmpPoint = world->me->pos;

			tmpPoint.SetX(tmpPoint.GetX() + 5);
			
			// Vhadzujem v hornej casti ihriska 
			if(tmpPoint.GetY() < 0)
				tmpPoint.SetY(tmpPoint.GetY() + 15);

			// Vhadzujem v spodnej casti ihriska
			else
				tmpPoint.SetY(tmpPoint.GetY() - 15);
			
			if(nKickInModeDuration++ < WAIT_TIMEOUT)
			{	
				if((nKickInModeDuration == 1) && (!world->me->IsLookingAt(tmpPoint)))
				{
					world->me->bNeckSynchronization = false;
					TurnTo(tmpPoint);
					return;
				}	
				else
				{
					return;
				}
			}
			
			StartPlayOnByPassToOurPlayer();
			return;
		}

		// <Vykopavanie> - pociatocne zahravanie zo stredu ihriska (Kick-off) alebo ak dostaneme gol
		if((world->state->GetPlayMode() == PM_KickOff_Our) || (world->state->GetPlayMode() == PM_AfterGoal_Their))
		{
			CEvaluatingPlayer* pEvPlayer = ePlayerList->GetKickOffPlayer();
			if(pEvPlayer != NULL)
			{
				Point playerPosition(pEvPlayer->GetPlayerXPosition(), pEvPlayer->GetPlayerYPosition());
				printf("Rozohravam hracovi c.%d na poziciu [%lf, %lf]\n", pEvPlayer->GetPlayerIDNumber(), pEvPlayer->GetPlayerXPosition(), pEvPlayer->GetPlayerYPosition());
				PassBallTo(playerPosition, 1);
				return;
			}
		}

		// <Pokutovy kop>
		if(world->state->GetPlayMode() == PM_PenaltyKick_Our)
		{
			KickToGoal3();
			return;
		}

	}

	// <HERNI MOD> (HRA SA)
	else
	{
		// <Strelba na branu>
		if(ShouldKickOnGoal())
		{
			KickToGoal3();

			log1 << "KickToGoal3()" << endl;
			log1.close();

			return;
		}
		else if(DistanceToGoal(myPosition) < 16.0)
		{
			KickToGoal3();

			log1 << "KickToGoal3()" << endl;
			log1.close();

			return;
		}
		// <Nahravanie>
		else if(ePlayerList->CalculateNormalPassPosition(myPosition.GetX(), myPosition.GetY(), lfTmpX, lfTmpY))
		{
			// <Prioritny dribling>
			if(ePlayerList->NoEnemiesAround(myPosition))
			{
				if(!ManageDribblePoint())
				{	
					ClearBall();
					return;
				}
				else
				{
					DribbleTo2(Point(lfDribbleX, lfDribbleY), 0);
					
					log1 << "Vypocitany driblovaci bod: (" << lfDribbleX << ", " << lfDribbleY << ")"  << endl;
					log1 << "DribbleTo2()" << endl;
					log1.close();

					//	Ak nevidim brankara a uz by som ho mal vidiet, skus ho najst otocenim krku
					if(DistanceToGoal(world->me->pos) <= 40)
					{
						TurnNeckTo(Point(36, 0), world->ball->pos, 0);
						log1 << "TurnNeckTo(Point(36, 0))" << endl;
						log1.close();
					}
					
					return;
				}
			}
			else
			{
				Point passPosition(lfTmpX, lfTmpY);
				DBGN("Prihravka na (%.3lf, %.3lf)", passPosition.GetX(), passPosition.GetY());
				
				Vector vectFromMeToPassPoint = passPosition - world->me->pos;
				float lfDistance = vectFromMeToPassPoint.GetLength();
				float lfPassSpeed = (lfDistance - lfMinPassDistance) / (lfMaxPassDistance - lfMinPassDistance) * (world->params->server->ball_speed_max - 1.4) +  1.4;
				
				ofstream out("Normalne prihavanie.txt", ios::app); // Zapis do suboru
				int nSimTime = world->state->GetSimTime();
				int nPlayerNumber = world->me->GetUniform();
				out << "[" << nSimTime << "]" << " Hrac c." << nPlayerNumber << endl;
				out.close();

				PassBallTo(passPosition, CorrectPassSpeed(lfPassSpeed));
				return;
			}
		}
		// <Dribling>
		else
		{
			// Ak je brankar nebezpecne blizko a strielat nie je vhodne
			if(enemyGoalie != NULL && (enemyGoalie->pos - world->ball->pos).GetLength() < 4.f)
			{	
				Vector meGoalie = (enemyGoalie->pos - world->me->pos);
				
				if(world->me->pos.GetY() > 0)
					meGoalie.SetAngle(meGoalie.GetAngle() - DegAngle(70));
				else
					meGoalie.SetAngle(meGoalie.GetAngle() + DegAngle(70));

				float lfDistance = meGoalie.GetLength();
				float lfPassSpeed = (lfDistance - lfMinPassDistance) / (lfMaxPassDistance - lfMinPassDistance) * (world->params->server->ball_speed_max - 1.4) +  1.4;
				
				PassBallTo(world->me->pos + meGoalie, CorrectPassSpeed(lfPassSpeed));
				return;
			}

			else if(IsPointInRectArea(myPosition.GetX(), myPosition.GetY(), 32.0, -20.16, 52.5, 20.16))
			{
				KickToGoal3();
				log1 << "KickToGoal3()" << endl;
				log1.close();

				return;
			}
		
			// Ak som hlboko v pasme supera a v obrannom pasme supera a v obrannom pasme supera su nejaki moji hraci
			else if((IsPointInRectArea(myPosition.GetX(), myPosition.GetY(), 25.0, -25.0, 52.5, 25.0)) && (ePlayerList->OurPlayersInEnemyPenaltyArea()))
			{
					Point passPosition;

					// Mozem skusit krizovu prihravku pred branou
					if(myPosition.GetY() < 0)
					{
						passPosition.SetX(40.0); passPosition.SetY(8.0);
					}
					else if (myPosition.GetY() > 0)
					{
						passPosition.SetX(40.0); passPosition.SetY(-8.0);
					}
					
					Vector vectFromMeToPassPoint = passPosition - world->me->pos;
					float lfDistance = vectFromMeToPassPoint.GetLength();
					float lfPassSpeed = world->params->server->ball_speed_max;
					
					PassBallTo(passPosition, CorrectPassSpeed(lfPassSpeed));
					return;
				}

			// Ak je pri mne NEARBY hrac, tak sa lopty treba zbavit
			else if(ePlayerList->NearbyEnemiesAround(myPosition))
			{
				// Predkopnem si loptu
				double lfShortKickX = myPosition.GetX();
				double lfShortKickY = myPosition.GetY();

				if(ePlayerList->CalculateOptimalDribblePointAux(lfShortKickX, lfShortKickY, 10.0))
				{
				
					if(ShortKick(Point(lfShortKickX, lfShortKickY)))
						return;
					else
					{
						if(!ManageDribblePoint())
						{	
							ClearBall();
							return;
						}
						else
						{
							DribbleTo2(Point(lfDribbleX, lfDribbleY), 0);

							log1 << "Vypocitany driblovaci bod: (" << lfDribbleX << ", " << lfDribbleY << ")"  << endl;
							log1 << "DribbleTo2()" << endl;
							log1.close();

							//	Ak nevidim brankara a uz by som ho mal vidiet, skus ho najst otocenim krku
							if(DistanceToGoal(myPosition) <= 35)
							{
								TurnNeckTo(Point(36, 0), world->ball->pos, 0);
								log1 << "TurnNeckTo(Point(36, 0))" << endl;	
								log1.close();
							}
							return;
						}
					}
				}
				else
				{
					ClearBall();
					return;
				}
			}
			else
			{
				if(GetNearestEnemyDistance(myPosition) >= 5.0f)
				{
					if(!ManageDribblePoint())
					{	
						ClearBall();
						return;
					}
					else
					{
						DribbleTo2(Point(lfDribbleX, lfDribbleY), 0);

						log1 << "Vypocitany driblovaci bod: (" << lfDribbleX << ", " << lfDribbleY << ")"  << endl;
						log1 << "DribbleTo2()" << endl;
						log1.close();

						//	Ak nevidim brankara a uz by som ho mal vidiet, skus ho najst otocenim krku
						if(DistanceToGoal(myPosition) <= 35)
						{
							TurnNeckTo(Point(36, 0), world->ball->pos, 0);
							log1 << "TurnNeckTo(Point(36, 0))" << endl;	
							log1.close();
						}
						return;
					}
				}
				else
				{
					if(GetNearestEnemyDistance(myPosition) <= 1.5f)
					{
						ClearBall();
						return;
					}
					else
					{
						OutPlayOpponent();
						return;
					}
				}
			}
		}
	}	
	
	// Toto by sa nemalo stat
	log1 << "HRAC NEVYUZIL CYKLUS!!!" << endl;
	log1.close();
	return;
}

// --------------------------------------------------------------------------------------------------------------- //

// Spravanie hraca bez lopty
void PlayerTactics::BehaveWithoutBall()
{
	if((world->ball->pos - world->me->pos).GetLength() < 5.0)
		world->me->bNeckSynchronization = false;
	else
		world->me->bNeckSynchronization = true;

	// Inicializacia
	PlayMode pm = world->state->GetPlayMode();
	Point myPositon = world->me->pos;
	int myUniform = world->me->GetUniform();
	
	bool bIgnoreBall = false;

	// Informacie o lopte nie su platne
	if(!world->ball->IsValid())
	{
		world->me->bNeckSynchronization = false;
		int nTimeWithoutBallInfo = world->me->GetSeeCount();

		if(nTimeWithoutBallInfo <= 1)
		{
			Point tmp = world->ball->pos + (world->ball->vel * world->params->server->ball_speed_max / 2.0 * nTimeWithoutBallInfo);
			TurnNeckTo(tmp, world->me->pos);
		}
		else if(nTimeWithoutBallInfo <= 2)
		{
			TurnTo(world->ball->pos + (world->ball->vel * world->params->server->ball_speed_max));
			NeckSynchronizationWithVI(ALIG_NECK);
		}
		
		if(nTimeWithoutBallInfo <= 4)
		{
			Point tmp = world->ball->pos + world->ball->vel * (world->params->server->ball_speed_max / 2.0) * nTimeWithoutBallInfo;
			TurnNeckTo(tmp, world->me->pos);
		}
		else
		{
			
			Vector tmpVector = (world->ball->pos - myPositon) * 25;
			
			if((nTimeWithoutBallInfo % 3) == 0)
			{
				TurnTo(myPositon +  tmpVector);
				NeckSynchronizationWithVI(ALIG_NECK);
			}
			else
			{
				TurnTo(myPositon +  tmpVector * -1);
				NeckSynchronizationWithVI(ALIG_NECK);
			}
		}

		return;
	}

	// Informacie o lopte su validne
	Point ballPosition = world->ball->pos;
	scanBeforeKickOffAngle = 0;

	//	<NASE ZAHRAVANIE>
	
	// <Rohovy kop>
	if(pm == PM_CornerKick_Our)
	{
		// Rozohravatel nasho rohoveho kopu
		int nCornerKickerUniform;
		
		if(ballPosition.GetY() < 0)
			nCornerKickerUniform = 10;
		else
			nCornerKickerUniform = 11;

		if(myUniform == nCornerKickerUniform)
		{
			RunToPosition(ballPosition, 1);
		}
		else
		{
			Point CornerKickPositions[11] =
			{
				Point(-45,   0),	// Brankar
				Point(  0, -16),	// Hrac c. 2
				Point(  0,  16),	// Hrac c. 3
				Point( 10,   0),	// Hrac c. 4
				Point( 43, -10),	// Hrac c. 5
				Point( 30,  24),	// Hrac c. 6
				Point( 16,  13),	// Hrac c. 7
				Point( 34,  11),	// Hrac c. 8
				Point( 34,  -2),	// Hrac c. 9
				Point( 48,  25),	// Hrac c. 10
				Point( 48,  25),	// Hrac c. 11
			};

			if(ballPosition.GetY() < 0)
			{
				for(int i = 0; i < 11; i++)
				{
					CornerKickPositions[i].SetY(-1 * CornerKickPositions[i].GetY());
				}
			}

			RunToPosition(CornerKickPositions[myUniform - 1], 1);
		}

		return;
	}
	else if(pm == PM_FreeKick_Our || pm == PM_IndFreeKick_Our)
	{
		if(myUniform == 5)
		{
			RunToPosition(ballPosition, 1);
			return;
		}

		Vector possibility1 = ballPosition -  Point(36, -20.16f);
		Vector possibility2 = ballPosition -  Point(36,  20.16f);

		
		if((possibility1.GetLength() < 1.5) || (possibility2.GetLength() < 1.5))
		{
			ExitOffside();
			return;
		}
		else
		{
			if(myUniform == 6)
			{
				RunToPosition(Point(ballPosition.GetX() + 6, ballPosition.GetY() - 8), 1);
				return;
			}
			else if(myUniform == 7)
			{
				RunToPosition(Point(ballPosition.GetX() + 12, ballPosition.GetY()), 1);
				return;
			}
			else if(myUniform == 8)
			{
				RunToPosition(Point(ballPosition.GetX() + 6, ballPosition.GetY() + 8), 1);
				return;
			}
		}

		ExitOffside();
				
	}
	else if(pm == PM_GoalKick_Our)
	{
		if(myUniform == 1)
		{
			RunToPosition(ballPosition, 1);
			return;
		}
		else if(myUniform == 2)
		{
			RunToPosition(Point(-27, 0), 1);
			return;
		}
		else if(myUniform == 3)
		{
			RunToPosition(Point(-32, -16), 1);
			return;
		}
		else if(myUniform == 4)
		{
			RunToPosition(Point(-32, 16), 1);
			return;
		}
		else
		{
			bIgnoreBall = false;
		}
	}
	else if(pm == PM_KickIn_Our)
	{
	
		// Rozohravatel nasho vhadzovania
		int nKickInUniform;
		
		if(ballPosition.GetY() < 0)
		{
			nKickInUniform = 6;

			if(myUniform == nKickInUniform)
			{
				RunToPosition(ballPosition, 1);
				return;
			}
			else if(myUniform == 3)
			{
				RunToPosition(Point(ballPosition.GetX() - 15, ballPosition.GetY() + 8), 1);
				return;
			}
			else if(myUniform == 5)
			{
				RunToPosition(Point(ballPosition.GetX(), ballPosition.GetY() + 10), 1);
				return;
			}
			else if(myUniform == 10)
			{
				RunToPosition(Point(ballPosition.GetX() + 15, ballPosition.GetY() + 3), 1);
				return;
			}
			else
			{	
				bIgnoreBall = true;
			}
		}
		else if(ballPosition.GetY() > 0)
		{
			nKickInUniform = 7;

			if(myUniform == nKickInUniform)
			{
				RunToPosition(ballPosition, 1);
				return;
			}
			else if(myUniform == 4)
			{
				RunToPosition(Point(ballPosition.GetX() - 15, ballPosition.GetY() - 8), 1);
				return;
			}
			else if(myUniform == 5)
			{
				RunToPosition(Point(ballPosition.GetX(), ballPosition.GetY() - 10), 1);
				return;
			}
			else if(myUniform == 11)
			{
				RunToPosition(Point(ballPosition.GetX() + 15, ballPosition.GetY() - 3), 1);
				return;
			}
			else
			{
				bIgnoreBall = true;
			}
		}

		return;
	}
	else if(pm == PM_KickOff_Our)
	{
		if(myUniform == 9)
		{
			RunToPosition(ballPosition, 1);
			return;
		}
		else
		{
			bIgnoreBall = true;
		}
	}
	else if(pm == PM_PenaltyKick_Our)
	{
		bIgnoreBall = true;
	}


	//	<SUPEROVE ZAHRAVANIE>
	
	// <Rohovy kop>
	if(pm == PM_CornerKick_Their)
	{
		Point CornerKickPositions[11] =
		{
			Point(-48,   9),	// Brankar
			Point(-40,  13),	// Hrac c. 2
			Point(-50,  23),	// Hrac c. 3
			Point(-46,  23),	// Hrac c. 4
			Point(-40,   3),	// Hrac c. 5
			Point(-45, -13),	// Hrac c. 6
			Point(-42,  23),	// Hrac c. 7
			Point(-19, -12),	// Hrac c. 8
			Point(-19,  12),	// Hrac c. 9
			Point(-40,  13),	// Hrac c. 10
			Point(-38,  23),	// Hrac c. 11
		}; 

		if(ballPosition.GetY() < 0)
		{
			for(int i = 0; i < 11; i++)
			{
				CornerKickPositions[i].SetY(-1 * CornerKickPositions[i].GetY());
			}
		}

		RunToPosition(CornerKickPositions[myUniform - 1], 1);
		
		return;
	}
	else if(pm == PM_FreeKick_Their || pm == PM_IndFreeKick_Their)
	{	
		Vector possibility1 = ballPosition -  Point(-36, -20.16f);
		Vector possibility2 = ballPosition -  Point(-36,  20.16f);

		
		if((possibility1.GetLength() < 1.5) || (possibility2.GetLength() < 1.5))
		{
			if(myUniform == 2)
			{
				RunToPosition(Point(ballPosition.GetX(), ballPosition.GetY() - 10), 1);
				return;
			}
			else if(myUniform == 3)
			{
				RunToPosition(Point(ballPosition.GetX() - 8, ballPosition.GetY() - 8), 1);
				return;
			}
			else if(myUniform == 4)
			{
				RunToPosition(Point(ballPosition.GetX() - 8, ballPosition.GetY() + 8), 1);
				return;
			}
			else if(myUniform == 5)
			{
				RunToPosition(Point(ballPosition.GetX() - 6, ballPosition.GetY() + 10), 1);
				return;
			}

			return;
		}
		else
		{
			if(myUniform == 5)
			{
				RunToPosition(Point(ballPosition.GetX() - 8, ballPosition.GetY()), 1);
				return;
			}
			else if(myUniform == 6)
			{
				RunToPosition(Point(ballPosition.GetX() - 5, ballPosition.GetY() - 6), 1);
				return;
			}
			else if(myUniform == 7)
			{
				RunToPosition(Point(ballPosition.GetX() - 6, ballPosition.GetY() - 4), 1);
				return;
			}
		}
		
		bIgnoreBall = false;		
	}
	else if(pm == PM_GoalKick_Their)
	{
		bIgnoreBall = false;	
	}
	else if(pm == PM_KickIn_Their)
	{
		if(ballPosition.GetY() < 0)
		{
			if(myUniform == 3)
			{
				RunToPosition(Point(ballPosition.GetX() - 15, ballPosition.GetY() + 15), 1);
				return;
			}
			else if(myUniform == 5)
			{
				RunToPosition(Point(ballPosition.GetX(), ballPosition.GetY() + 15), 1);
				return;
			}
			else if(myUniform == 10)
			{
				RunToPosition(Point(ballPosition.GetX() + 15, ballPosition.GetY() + 15), 1);
				return;
			}
			else
			{
				bIgnoreBall = true;
			}
		}
		else if(ballPosition.GetY() > 0)
		{
			if(myUniform == 4)
			{
				RunToPosition(Point(ballPosition.GetX() - 15, ballPosition.GetY() - 15), 1);
				return;
			}
			else if(myUniform == 5)
			{
				RunToPosition(Point(ballPosition.GetX(), ballPosition.GetY() - 15), 1);
				return;
			}
			else if(myUniform == 11)
			{
				RunToPosition(Point(ballPosition.GetX() + 15, ballPosition.GetY() - 15), 1);
				return;
			}
			else
			{
				bIgnoreBall = true;
			}
		}

		return;
	}

	// Nabiehavanie si niektorych hracov pri zahravani
	if(SomeoneShouldKickIn())
	{
		Point pos;
		double lfNewPosX = world->me->pos.GetX();// pos.GetX();
		double lfNewPosY = world->me->pos.GetY();// pos.GetY();

		if(!ePlayerList->CalculateReceiveBallPositionAux(lfNewPosX, lfNewPosY, world->ball->pos.GetX(), world->ball->pos.GetY()))
		{
			pos.SetX(lfNewPosX);
			pos.SetY(lfNewPosY);

			RunToPosition(pos, 2);
			return;
		}
	}
	

	// Ked som natoceny na branku a moze padnut gol smykackou
	float posX = world->params->flags[GOAL_R].GetX();
	
	Point tGoal(posX, -(world->params->server->goal_width / 2) * .9f);
	Point bGoal(posX, (world->params->server->goal_width / 2) * .9f);
	
	Vector tVect = tGoal - world->me->pos;
	Vector bVect = bGoal - world->me->pos;

	Player* enemyGoalie = GetEnemyGoalie();

	if(CanTackleBall() && world->me->GetAbsDir().GetDeg() >= tVect.GetAngle().GetDeg() && 
	   world->me->GetAbsDir().GetDeg() <= bVect.GetAngle().GetDeg() && 
	   (ShouldKickOnGoal() || (enemyGoalie != NULL && (enemyGoalie->pos - world->ball->pos).GetLength() < 4.f)))
	{
		TXTN("%d: I am tackling", world->state->GetSimTime());
		Tackle(100.0f);
		return;
	}

	bool bInterceptBall = false;
/*	
	// Nesnaz sa zasahovat do modu GoalKick
	// GoalKick a FreeKick trva az dokial lopta neopusti pokutove pasmo.

	bool goalKickIgnore = world->state->GetPlayMode() == PM_GoalKick_Our;
		
	// Neignoruj loptu, ak nie je blizko brankara v GoalKick/FreeKick mode
	Player *goalie = world->FindFriend(1);
	bool doNotIgnore = !world->ball->IsValid() || goalie == NULL;
	
	if(!doNotIgnore)
		doNotIgnore = doNotIgnore || (world->ball->pos - goalie->pos).GetLength() > 0.105;
	
	// Snaz sa zachytit loptu
	if(doNotIgnore || (!goalKickIgnore && !letGoalieRest))
		catchIt = InterceptBall();
*/

	if(!bIgnoreBall)
		bInterceptBall = InterceptBall();
	
	if(!bInterceptBall)
	{				
		const float off_l = GetOffsideLine();

		if(InOffsidePos())
		{
			// Je v ofsajde
			ExitOffside();
		}
		else
		{

			m_cFormation.SetSide( SIDE_LEFT );
			Point pos = m_cFormation.GetPlayerPosition( world->me->GetUniform(), world->ball->pos);

			double lfNewPosX = world->me->pos.GetX();// pos.GetX();
			double lfNewPosY = world->me->pos.GetY();// pos.GetY();

/*			if( ((pos.GetX() >= -40) && (pos.GetX() <= -25)) && ((myUniform == 2) || (myUniform == 3) || (myUniform == 4)) )
			{
				if (myUniform == 2)
				{
					pos = Point(-36, 0);
				}
				else if (myUniform == 3)
				{
					pos = Point(-36, -14);
				}
				else if (myUniform == 4)
				{
					pos = Point(-36, 14);
				}
			}
			else 
*/			if(!ePlayerList->CalculateReceiveBallPositionAux(lfNewPosX, lfNewPosY, world->ball->pos.GetX(), world->ball->pos.GetY()))
			{
				pos.SetX(lfNewPosX);
				pos.SetY(lfNewPosY);
			}
			

			Vector dist = pos - world->me->pos;

			if(dist.GetLength() > 2.0)
			{
				// Test na ofsajd
				if(pos.GetX() > off_l - 0.1f)
					pos.SetX(off_l - 1.0f);
				// Pobehni na svoju poziciu
				RunToPosition(pos, 1);
			}
			else
			{
				// Ak som blokovany superom, pobehni trochu blizsie k lopte
				Vector shift;
				if(UnblockMyself(&shift))
				{
					Point tmp = world->me->pos + shift;
					UBLK_DBGN("%i: Unblocking by (%3.2f, %3.2f) - from (%3.2f, %3.2f) to (%3.2f, %3.2f)", world->state->GetSimTime(), shift.GetX(), shift.GetY(), world->me->pos.GetX(), world->me->pos.GetY(), tmp.GetX(), tmp.GetY());

					// test offside
					if(tmp.GetX() > off_l - 0.1f)
						tmp.SetX(off_l - 1.0f);
					// pobehni na svoju poziciu
					RunToPosition(tmp, 2);
				}
				
			}
		}
	}

}

//
void PlayerTactics::BehaveWithBallGoalie()
{
	WARNN("I am not goalie, why BehaveWithBallGoalie???");
	BehaveWithBall();
}

//
void PlayerTactics::BehaveWithoutBallGoalie()
{
	WARNN("I am not goalie, why BehaveWithoutBallGoalie???");
	BehaveWithoutBall();
/*	//bool catchIt = DependentForBall();
	//if(catchIt) 
	bool catchIt = InterceptBall();

	if(!catchIt)
	{
		TurnTo(world->ball->pos);
		NeckSynchronizationWithVI(ALIG_NECK);
	}
*/
}

// Vypocita a vrati vzdialenost k branke
float PlayerTactics::DistanceToGoal(const Point& pos) const
{
	const float posX = 52.5f;

	if (pos.GetY() < -world->params->server->goal_width / 2)
	{
		const Point UpperGoal(posX, -world->params->server->goal_width / 2);
		return (UpperGoal - pos).GetLength();
	}

	if (pos.GetY() > world->params->server->goal_width / 2) {
		const Point LowerGoal(posX, world->params->server->goal_width / 2);
		return (LowerGoal - pos).GetLength();
	}

	return fabsf(posX - pos.GetX());
}

// Hrac preskuma najblizsie okolie okolo seba otocenim sa okolo vlastnej osi
void PlayerTactics::ExamineSurroundings()
{
	// Skenovanie okolia - kontrola situacie pred zahranim.
	world->me->bNeckSynchronization = false;
	
	if(scanBeforeKickOffAngle <= 360)
	{
		DBGN("Skenujem okolie");
		
		scanBeforeKickOffAngle += Scan();
		return;
	}
}

// Hrac odbehne z ofsajdu
void PlayerTactics::ExitOffside()
{
	RunToPoint(Point((GetOffsideLine() - 1.0f), world->me->pos.GetY()), true);
}

// Vrati pointer na superovho brankara. Vrati NULL, ak superov brankar nie je v hracovom svete
Player* PlayerTactics::GetEnemyGoalie() const
{
	static Player *enemyGoalie;
	static int i;
	
	enemyGoalie = NULL;
	for(i = 0; i < world->enemies.GetSize(); i++)
	{
		if(world->enemies[i].IsGoalie()) 
		{
			enemyGoalie = &(world->enemies[i]);
			break;
		}
	}
	return enemyGoalie;
}

// Vrati domovsku poziciu
Point PlayerTactics::GetHomePos()
{
	float s = -27.0f;
	m_cFormation.SetSide(SIDE_LEFT);
	
	//CfPoint homepos = m_cFormation.GetPlayerPosition( world->me->Unum, CfPoint( s, 0) );
    Point homepos = m_cFormation.GetPlayerPosition( world->me->GetUniform(), Point(s, 0) );
	homepos.SetX((homepos.GetX() > -2.f) ? -2.f : homepos.GetX());
//	if (world->me->GetUniform() < m_cFormation.GetPlayersCountInUnit(m_cFormation.m_nUnitDef)
	
	return homepos;
}

//Zisti silu potrebnu na kopnutie lopty na urcite miesto za urcity pocet cyklov
// ciel -> miesto, kde sa ma lopta kopnut
// steps -> kolko cyklov to ma trvat
// Vrati sa pozadovana sila kopnutia
float PlayerTactics::GetKickPower(const Point& ciel, int steps)
{
	int nStepTolerance = 5;
	Vector path = ciel - world->ball->pos;
	float vzdial = path.GetLength();
	float req_spd = vzdial * (1.0f - world->params->server->ball_decay) / (1.0f - float(pow(world->params->server->ball_decay, steps - 1)));
  
	if (req_spd > world->params->server->ball_speed_max)
	{
		req_spd = vzdial * (1.0f - world->params->server->ball_decay) / (1.0f - float(pow(world->params->server->ball_decay, steps + nStepTolerance)));
		return req_spd;
    }
  
	return req_spd;
}

// Vypocita sa vzdialenost k najblizsiemu superovi
// target -> cielovy referencny bod
// Vrati sa vzdialenost
float PlayerTactics::GetNearestEnemyDistance(const Point& target)
{
  
	float fMinDistance = 1000.0;
	
	for(int i = 0; i < world->enemies.GetSize(); i++)
	{
	  float fDiffEnemy = (world->enemies[i].pos - target).GetLength();
    
	  if (fDiffEnemy < fMinDistance)
		fMinDistance = fDiffEnemy;
    }

	return fMinDistance;
}

// Vrati najblizsi index supera
Player PlayerTactics::GetNearestEnemy(const Point& target)
{
	float min = 1000.0;
	int player = -1;

	for(int i = 0; i < world->enemies.GetSize(); i++)
	{
		float diff = (world->enemies[i].pos - target).GetLength();
		if(diff < min)
		{
			min = diff;
			player = i;
		}
	}

	return world->enemies[player];
}

// Najde najblizsieho spoluhraca
// target -> cielovy referencny bod
// Vrati sa najblizsi index hraca, -1 ak ziadny
int PlayerTactics::GetNearestFriend(const Point& target)
{
	float min = 1000.0;
	int player = -1;

	for(int i = 0; i < world->friends.GetSize(); i++)
	{
		float diff = (world->friends[i].pos - target).GetLength();
		if(diff < min)
		{
			min = diff;
			player = i;
		}
	}

	return player;
}

// Vypocita vzdialenost k najblizsiemu spoluhracovi
// target -> Cielovy referencny bod
// Vrati sa vzdialenost
float PlayerTactics::GetNearestFriendDistance(const Point& target)
{
	int player = GetNearestFriend(target);
	return player == -1 ? 1000.0f : (world->friends[player].pos - target).GetLength();
}

// Najde lepsiu poziciu pre obdrzanie nahravky a presunie tam hraca.
// Vrati sa true, ak sa hrac presunul, false, ak sa nenaslo ziadne lepsie miesto.
bool PlayerTactics::GotoPositionToPass()
{
	Vector positions[10];
	positions[0].SetX(5.0f);
	positions[0].SetY(0.0f);
	positions[1].SetX(3.5f);
	positions[1].SetY(3.5f);
	positions[2].SetX(3.5f);
	positions[2].SetY(-3.5f);
	positions[3].SetX(0.0f);
	positions[3].SetY(5.0f);
	positions[4].SetX(0.0f);
	positions[4].SetY(-5.0f);

	int i;
	for (i = 0; i < 5; i++)
	{
		positions[i + 5].SetX(positions[i].GetX() * 2);
		positions[i + 5].SetY(positions[i].GetY() * 2);
	}

	Point fpDefaultPosition = GetHomePos();
	float fMyEnemyDistance = GetNearestEnemyDistance(world->me->pos);
	// Pre kazdu z pozicii zistim, ci tam hrac moze ist
	for (i = 0; i < 10; i++)
	{
		Point fpDestination = world->me->pos + positions[i];
		
		if (IsOffsidePosition(fpDestination) == true)
			continue;
		
		float fTargetDistance = (fpDestination - fpDefaultPosition).GetLength();
		float fMyDistance = (world->me->pos - fpDefaultPosition).GetLength();
		
		if (fTargetDistance < 20.0f || fTargetDistance < fMyDistance)
		{
			// Teoreticky tam mozem ist, este zistit, ci sa to oplati...
			float fTargetEnemyDistance = GetNearestEnemyDistance(fpDestination);
			if (fTargetEnemyDistance > (fMyEnemyDistance + 2.0f) && GetNearestFriendDistance(fpDestination) > 5.0f)
			{
				RunToPoint(fpDestination, true);
				return true;
			}
		}
	}
	
	return false;
}

// Zmeni formaciu
void PlayerTactics::ChangeFormation(const char* formation)
{
    int unitcount1, unitcount2, unitcount3;

    unitcount1 = (int)(formation[9] - '0');
    unitcount2 = (int)(formation[10] - '0');
    unitcount3 = (int)(formation[11] - '0');

    m_cFormation.InitRawUnits(SIDE_LEFT, GetFormation(formation), GetUnit(unitcount1, (char)formation[12]), GetUnit(unitcount2, 
		(char)formation[13]), GetUnit(unitcount3, (char)formation[14]));
	float offset = 2.0f*(formation[15]-'A') - FIELDWIDTH/2.0f;
	m_cFormation.SetUnitOffset((float)2.0f*(formation[15]-'A')- FIELDWIDTH/2.0f);
	TXTN("We are changing formation to %s", formation);
}

// Brani super v nasej prihravke na urcite miesto?
bool PlayerTactics::IsBlockingEnemy(const Point& target)
{
	Vector diffTarget = target - world->me->pos;
	float distToTarget = diffTarget.GetLength();

	for(int e = 0; e < world->enemies.GetSize(); e++)
	{
		Vector diffEnemy = world->enemies[e].pos - world->me->pos;
		float fDistToEnemy = diffEnemy.GetLength();

	    if(fDistToEnemy < distToTarget && fDistToEnemy > 2)
		{
  			if((diffTarget.GetAngle() - diffEnemy.GetAngle()).GetAbsDeg() < 17)
			{
				return true;
			}
		}
	}
	
	return false;
}

// Zisti, ci cielovy bod je v ofsajde
// target -> skumana pozicia
// Vrati sa true, ak ak je ofsajde, false inak
bool PlayerTactics::IsOffsidePosition(Point target)
{
	const float off_l = GetOffsideLine();

	if(target.GetX() >= off_l && world->me->pos.GetX() > off_l - 1.0f)
		return true;

	return false;
}

// Tato metoda riadi vypocitavanie optimalneho driblovacieho bodu
bool PlayerTactics::ManageDribblePoint()
{
	bool bResult = true;

	int nActualCycle = world->state->GetSimTime();
	
//	if(nActualCycle - 2 > nLastDribblePointCalculationCycle)
//	{
		lfDribbleX = world->me->pos.GetX();
		lfDribbleY = world->me->pos.GetY();

		bResult = ePlayerList->CalculateOptimalDribblePointAux(lfDribbleX, lfDribbleY, 8.0);
		nLastDribblePointCalculationCycle = nActualCycle;
		
//	}

		return bResult;		
}

// Su nejaki superi okolo? Ak nie, tak by mal hrac driblovat.
bool PlayerTactics::NoEnemiesAround() const
{
	if(DistanceToGoal(world->me->pos) < 18)
		return false;

	for (int i = 0; i < world->enemies.GetSize(); i++)
	{
		if ((world->enemies[i].pos - world->me->pos).GetLength() <= 5.0f &&
			(world->enemies[i].pos - world->me->pos).GetAngle().GetAbsDeg() < 90) 
		{
			DBGN("%d: %.2f", world->state->GetSimTime(), 
				(world->enemies[i].pos - world->me->pos).GetAngle().GetAbsDeg());
			return false;
		}
	}

	return true;
}

// Zmeni handler hracieho modu
void PlayerTactics::OnChangeMode(int time, PlayMode mode)
{
	// Pocas trvania modu PM_FreeKick_Our ignoruj loptu. Nechaj brankara odpocivat, ak to chce.
	letGoalieRest = false;
	
	if(mode == PM_FreeKick_Our)
	{
		PlayMode previousMode = world->state->GetPlayMode();
		
		if(previousMode == PM_GoalieCatch_Our)
			letGoalieRest = true;
	}
		
	// Vola pretazene metody
#ifdef TRAINING
	PlayerSkills::OnChangeMode(time, mode);
#else
	PlayerKernel::OnChangeMode(time, mode);
#endif
	
	// Ak je to jeden z vykopavacich modov, tak zacni scanovanie okoliteho okolia. Pozri BehaveWithBall()
	scanBeforeKickOffAngle = 0;

	nCornerKickModeDuration = 0;
	nFreeKickModeDuration = 0;
	nIndFreeKickModeDuration = 0;
	nKickInModeDuration = 0;
}

// Hrac si predkopne loptu popri superovi
void PlayerTactics::OutPlayOpponent()
{
	Player nearestEnemy = GetNearestEnemy(world->me->pos);
	Vector vectFromMeToEnemy = (nearestEnemy.pos - world->me->pos);
	
	if(vectFromMeToEnemy.GetAngle().GetDeg() > 0)
		vectFromMeToEnemy.SetAngle(vectFromMeToEnemy.GetAngle() - DegAngle(40));
	else
		vectFromMeToEnemy.SetAngle(vectFromMeToEnemy.GetAngle() + DegAngle(40));

	float lfDistance = vectFromMeToEnemy.GetLength();
	float lfPassSpeed = (lfDistance - lfMinPassDistance) / (lfMaxPassDistance - lfMinPassDistance) * (world->params->server->ball_speed_max - 1.425) +  1.425;
	
	PassBallTo(world->me->pos + vectFromMeToEnemy, CorrectPassSpeed(lfPassSpeed));
	TurnNeckTo(world->me->pos + vectFromMeToEnemy, world->ball->pos, 0);
}

// Prihravanie beziacemu hracovi (ak je to mozne).
// Vrati sa true, ak sa nahralo, inak false.
bool PlayerTactics::PassIntoRun()
{
//	return false;

	if(world->me->pos.GetX() < world->variables->GetMinXPosition())
		return false;
  
	float fOurPlayerAdvantage = 0.2f;
	int n;

	for(int who = 0; who < world->friends.GetSize(); who++)
	{
		if(world->friends[who].pos.GetX() <= (world->me->pos.GetX() - 10.0f))
			continue;
		
/*		for(n = 40; n > 10;  n = n - 2) 
		{
			float pos = world->friends[who].pos.GetX() + n;
			Point destination(pos, world->friends[who].pos.GetY());
			float diff = (destination - world->friends[who].pos).GetLength();
			float fNearestEnemy = GetNearestEnemyDistance(destination);
			
			if(diff > (fNearestEnemy - fOurPlayerAdvantage))
				continue;
			if(IsBlockingEnemy(destination))
				continue;

			int stepCount = int(diff / float(world->params->server->player_speed_max));
			float power = GetKickPower(destination, stepCount);
			//Point path = destination - world->ball->pos;
			//float vzdial = path.GetLength();
			
			if(power <= world->params->server->ball_speed_max) 
			{
				SKILLS_DBGN("%i: ->passing to run (really 1)", world->state->GetSimTime());
				SKILLS_DBGN("%i: ->%s player %i", world->state->GetSimTime(), world->friends[who].GetSide() == OUR ? "our" : (world->friends[who].GetSide() == THEIR ? ">>their<<" : ">>unknown<<"), world->friends[who].GetUniform());
				SKILLS_DBGN("%i: ->player pos (%3.2f, %3.2f) dest (%3.2f, %3.2f)", world->state->GetSimTime(), world->friends[who].pos.GetX(), world->friends[who].pos.GetY(), destination.GetX(), destination.GetY());

      			PassBallTo(destination, 0.2f);
				return true;
			}
		}
*/
		for(n = 40; n > 10;  n = n - 2)
		{
			float xpos = world->friends[who].pos.GetX() + n;
			float ypos = (world->me->pos.GetY() > world->friends[who].pos.GetY()) ? world->friends[who].pos.GetY() + n : world->friends[who].pos.GetY() - n;
			Point destination(xpos, ypos);
			float diff = (destination - world->friends[who].pos).GetLength();
			float fNearestEnemy = GetNearestEnemyDistance(destination);

			if(diff > (fNearestEnemy - fOurPlayerAdvantage)) continue;
			if(IsBlockingEnemy(destination)) continue;

			int stepCount = int(diff / float(world->params->server->player_speed_max));
			float power = GetKickPower(destination, stepCount);
			//Point path = destination - world->ball->pos;
			//float vzdial = path.GetLength();
			
			if(power <= world->params->server->ball_speed_max) 
			{
				SKILLS_DBGN("%i: ->passing to run (really 2)", world->state->GetSimTime());
				SKILLS_DBGN("%i: ->%s player %i", world->state->GetSimTime(), world->friends[who].GetSide() == OUR ? "our" : (world->friends[who].GetSide() == THEIR ? ">>their<<" : ">>unknown<<"), world->friends[who].GetUniform());
				SKILLS_DBGN("%i: ->player pos (%3.2f, %3.2f) dest (%3.2f, %3.2f)", world->state->GetSimTime(), world->friends[who].pos.GetX(), world->friends[who].pos.GetY(), destination.GetX(), destination.GetY());

      			PassBallTo(destination, 0.2f);
				return true;
			}
		}
	}

	return false;
}

// Beh na takticku poziciu alebo sledovanie lopty, ak uz tam hrac je
void PlayerTactics::Patrol() 
{
	Point fpTacticalPosition = GetHomePos();

	bool OffsideWarning = false; // ci idem do ofsajdu

	const float off_l = GetOffsideLine();
	
	if(fpTacticalPosition.GetX() >= off_l && world->me->pos.GetX() > off_l - 1.0f)
		OffsideWarning = true;

	if(fabsf(fpTacticalPosition.GetX() - world->me->pos.GetX()) > 5 || fabsf(fpTacticalPosition.GetY() - world->me->pos.GetY()) > 5) // takticky presun
	{
		// ak sa nedostanem do ofsajdu
		if(!OffsideWarning)
		{
			RunToPoint(fpTacticalPosition, true);
		}
		else if (OffsideWarning && fabsf(fpTacticalPosition.GetY() - world->me->pos.GetY()) > 5)
		{
			Point position(world->me->pos.GetX(), fpTacticalPosition.GetY());
			RunToPoint(position, false);
		} 
		else 
		{
  			TurnTo(world->ball->pos);
			NeckSynchronizationWithVI(ALIG_NECK);
		}
	}
	else // nepresuvam sa, iba sledujem loptu
	{
		TurnTo(world->ball->pos);
		NeckSynchronizationWithVI(ALIG_NECK);
	}
}

// Prihra na dane miesto kratkym kopnutim, ak sa tam dostane skor ako superi
bool PlayerTactics::ShortKick(const Point& pos)
{
	SKILLS_DBGN("%i: ->short kicking to position", world->state->GetSimTime());
	SKILLS_DBGN("%i: ->pos (%3.2f, %3.2f)", world->state->GetSimTime(), pos.GetX(), pos.GetY());

	const Vector diff = pos - world->ball->pos;
	const float dist = diff.GetLength();
	
	if(dist == 0)
		return false;

	if(!world->me->IsLookingAt(pos))
		return false;

	for(float d = 15.0f;d >= 5.0f; d -= 1.0f)
	{
		const Point target = world->ball->pos + diff * (d/dist);
		const int my_steps = PredictSteps((target - world->me->pos).GetLength(),RecommDashPower(true),0);
		float enemy_steps = 6000; // velke cislo

		for(int i = 0; i < world->enemies.GetSize(); i++)
		{
			enemy_steps = min(enemy_steps, (target - world->enemies[i].pos).GetLength()/world->params->server->player_speed_max);
		}

		if(my_steps < enemy_steps)
		{
			PassBallTo(target,0);
			return true;
		}
	}

	return false;
}

// Vrati true alebo false, podla toho, ci by tento hrac mal zahravat
bool PlayerTactics::ShouldKickIn()
{
	bool should = PlayerSkills::ShouldKickIn();
	
	if(!should)
		return false;

#ifdef GOALIE
	// Pre brankara PlayerSkills::ShouldKickIn() funguje dobre.

#else // GOALIE
	if(IsBallKickAble())
		return true;

	// Najdi hraca, ktoreho domovska pozicia je najblizsie k lopte
	float distance = 100000;	// velke cislo
	int uniform;

	m_cFormation.SetSide(SIDE_LEFT);
	for(int i = 1; i < 12; i++)
		if(m_cFormation.GetPlayerRole(/*SIDE_LEFT,*/ i - 1) != PR_Goalie)
		{
			Point pos = m_cFormation.GetPlayerPosition(i, world->ball->pos);
		
			float d = (pos - world->ball->pos).GetLength();
			
			if(d < distance)
			{
				distance = d; uniform = i;
			}
		}

	KICKIN_DBGN("%i: Number %i will kick in the ball", world->state->GetSimTime(), uniform);

	Point pos = m_cFormation.GetPlayerPosition(world->me->GetUniform(), world->ball->pos);
	
	if(fabsf((pos - world->ball->pos).GetLength() - distance) < 3.f)
		KICKIN_DBGN("%i: I am going to kick in", world->state->GetSimTime());
	else
		should = false;

#endif // GOALIE

	return should;
}

// Mal by hrac vystrelit na branku?
bool PlayerTactics::ShouldKickOnGoal()
{
	if(DistanceToGoal(world->ball->pos) > 20)
		return false;

	Player *enemyGoalie = GetEnemyGoalie();
	static int i;

	if(enemyGoalie == NULL)
	{
		// Brankara nevidim, ale moze byt prazdna branka
		if(world->me->IsLookingAt(Point(52.5, 0))) 
			return true;
		else
			return false;
	}

/*	if(enemyGoalie == NULL || enemyGoalie->GetAge() < 5)
	{
//		if(world->me->IsLookingAt(world->params->flags[GRT]) && 
//			world->me->IsLookingAt(world->params->flags[GRB])) return true;
		return false;
	}
*/

	float posX = world->params->flags[GOAL_R].GetX();
	Point tGoal(posX, -(world->params->server->goal_width / 2) * .9f);
	Point bGoal(posX, (world->params->server->goal_width / 2) * .9f);
	Vector tVect = tGoal - world->ball->pos;
	Vector bVect = bGoal - world->ball->pos;

	int maxCycleB, maxCycleT, cycle, cycleB, cycleT;
	float edp, ekp;
	Vector v, a;
	float catchableArea;

	const int MAX_CYCLE = 30;

	Point res, T1, T2;
	float deg;
	int cycleb;
	Point futBposT[MAX_CYCLE];
	Point futBposB[MAX_CYCLE];
	Point futureHePos[MAX_CYCLE];
	float runDist[MAX_CYCLE];
	int maxCycle;
	bool found;

	Player p(*enemyGoalie);
	Ball tmpBall(*world->ball);

	catchableArea = max(world->params->server->catchable_area_l, world->params->server->catchable_area_w);
	catchableArea *= 0.95f;

	// manual page 44
	edp = enemyGoalie->type->effort_max * enemyGoalie->type->dash_power_rate * 100;
	if(edp > world->params->server->player_accel_max) edp = world->params->server->player_accel_max;

	// manual page 48
	ekp = world->params->server->maxpower * world->params->server->kick_power_rate;
	float dir_diff = ((world->ball->pos - world->me->pos) - world->me->GetAbsDir()).GetAngle().GetAbsDeg();
	float dist_ball = (world->ball->pos - world->me->pos).GetLength() - world->params->server->ball_size - world->params->server->player_size;
	ekp *= 1.f - 0.25f * dir_diff / 180.f - 0.25f * dist_ball / world->me->type->kickable_margin;

	// lopta smerujuca k hornej a dolnej tycke
	Ball ballT(*world->ball);
	Ball ballB(*world->ball);
	ballT.vel.SetLength(ekp);
	ballT.vel.SetAngle(tVect.GetAngle());
	ballB.vel.SetLength(ballT.vel.GetLength());
	ballB.vel.SetAngle(bVect.GetAngle());

	deg = fabsf(p.GetAbsDir().GetDeg() - world->ball->vel.GetAngle().GetDeg());
	
	if(deg > 180)
		deg = 360 - deg;
	if(deg > 90)
		deg = 180; // pojde opacne (celom vpred)
	else
		deg = 0;

	futureHePos[0] = p.pos;
	runDist[0] = 0;
	v.SetLength(0);
	maxCycleB = maxCycleT = -1;
	
	for(cycleb = 1; cycleb < MAX_CYCLE; cycleb++)
	{
		// bez otacania
		a = PolarVector(edp, p.GetAbsDir() + DegAngle(deg));
		p.vel += a;
		if(p.vel.GetLength() > p.type->player_speed_max) p.vel.SetLength(p.type->player_speed_max);
		futureHePos[cycleb] = futureHePos[cycleb - 1] + p.vel;
		p.vel *= p.type->player_decay;

		// s otacanim
		if(cycleb > 1) 
		{
			v.SetLength(v.GetLength() + edp);
			
			if(v.GetLength() > p.type->player_speed_max)
				v.SetLength(p.type->player_speed_max);
		}
		runDist[cycleb] = runDist[cycleb - 1] + v.GetLength();
		
		if(cycleb > 1)
			v.SetLength(v.GetLength() * p.type->player_decay);

		// ball
		ballT.Step();
		ballB.Step();
		
		if(fabsf(ballT.pos.GetX()) > 52.5 && maxCycleT == -1)
			maxCycleT = cycleb;
		if(fabsf(ballB.pos.GetX()) > 52.5 && maxCycleB == -1)
			maxCycleB = cycleb;
		if(maxCycleB != -1 && maxCycleT != -1)
			break;
		
		futBposT[cycleb] = ballT.pos;
		futBposB[cycleb] = ballB.pos;
	}
	maxCycle = cycleb;
	
	if(maxCycleT == -1)
		maxCycleT = MAX_CYCLE;
	if(maxCycleB == -1)
		maxCycleB = MAX_CYCLE;

	found = true;

	p = *enemyGoalie;
	// bude sa pohybovat zotrvacnostou zatial co sa otaca
	p.pos = p.pos + p.vel;

	for(cycleB = 0; cycleB < maxCycleB; cycleB++)
	{
		// najskor skus bez otacania
		for(cycle = cycleB; cycle >= 0; cycle--)
		{
			if((futBposB[cycleB + 1] - futureHePos[cycle]).GetLength() <= catchableArea)
			{
				if(fabsf(futureHePos[cycle].GetX()) <= 52.5)
				{
					found = false;
					break;
				}
			}
		}
		if(!found)
			break;

		// teraz skus s otacanim
		for(cycle = cycleB; cycle >= 0; cycle--)
		{
			if((futBposB[cycleB + 1] - p.pos).GetLength() <= runDist[cycle] + catchableArea)
			{
				found = false;
				break;
			}
		}
	}

	if(found) 
	{ 
		TXTN("%d: Quite surely should be goal1", world->state->GetSimTime());
		TXTN(" (%.2f, %.2f, %.1f), (%.2f, %.2f) - %.2f", 
			enemyGoalie->pos.GetX(),
			enemyGoalie->pos.GetY(),
			enemyGoalie->GetAbsDir().GetDeg(),
			world->ball->pos.GetX(),
			world->ball->pos.GetY(),
			ekp);
		return found;
	}

	p = *enemyGoalie;
	// bude sa pohybovat zotrvacnostou zatial co sa otaca
	p.pos = p.pos + p.vel;

	for(cycleT = 0; cycleT < maxCycleT; cycleT++)
	{
		// najskor skus bez otacania
		for(cycle = cycleT; cycle >= 0; cycle--)
		{
			if((futBposT[cycleT + 1] - futureHePos[cycle]).GetLength() <= catchableArea)
			{
				if(fabsf(futureHePos[cycle].GetX()) <= 52.5)
				{
					found = false;
					break;
				}
			}
		}
		if(!found) break;

		// teraz skus s otacanim
		for(cycle = cycleT; cycle >= 0; cycle--)
		{
			if((futBposT[cycleT + 1] - p.pos).GetLength() <= runDist[cycle] + catchableArea)
			{
				found = false;
				break;
			}
		}
	}

	if(found)
	{
		TXTN("%d: Quite surely should be goal2", world->state->GetSimTime());
		TXTN(" (%.2f, %.2f, %.1f), (%.2f, %.2f) - %.2f", 
			enemyGoalie->pos.GetX(),
			enemyGoalie->pos.GetY(),
			enemyGoalie->GetAbsDir().GetDeg(),
			world->ball->pos.GetX(),
			world->ball->pos.GetY(),
			ekp);
	}
	return found;

}

// Vrati true a hrac dribluje k bodu, ak super nemoze kopnut do lopty. Inak vrati false.
bool PlayerTactics::SmartDribleTo(const Point& pos)
{

	if (DribbleTesting)
	{
		FCDribbleTo(pos);
	}

	int who;
	const float karea = world->variables->GetDribleSurroundingsMinWidth();
	for (who = 0; who < world->enemies.GetSize(); who++)
	{
		// protihrac uz moze kopnut do lopty
		if ((world->ball->pos - world->enemies[who].pos).GetLength() <= karea * 1.1f)
			return false;
	}

	const float dir = (pos - world->me->pos).GetAngle().GetDeg();
	const float controll_dist = world->params->server->ball_size + world->me->type->player_size + 0.45f * world->me->type->kickable_margin;

	float bestdir = 0;
	float maxvaha = 0;
	float vaha;

	for (float reldir = -90; reldir <= 90; reldir += 5)
	{
		float uhol = (dir + reldir) * M_PI/180;

		Point driblepos = world->me->pos + RectVector(cosf(uhol)* controll_dist,sinf(uhol) * controll_dist);

		vaha = 1000; // velke cislo
		for(who = 0; who < world->enemies.GetSize(); who++)
		{
			if((world->enemies[who].pos - world->me->pos).GetLength() > world->variables->GetDribleSurroundingsMaxWidth())
				continue;

			const float vzdial = (world->enemies[who].pos - driblepos).GetLength();
			
			if (vzdial <= karea)
			{
				vaha = 0;
				break;
			}
			if (!InTheMiddle(world->me->pos, driblepos, world->enemies[who].pos))
			{
				if (vzdial <= (karea + world->params->server->player_speed_max))
				{
					vaha = 0;
					break;
				}
				vaha = min(vaha, vzdial - (karea + world->params->server->player_speed_max));
			}
			else
			{
				vaha = min(vaha, vzdial - karea);
			}

		}

		if(vaha > maxvaha)
		{
			maxvaha = vaha;
			bestdir = reldir;
		}

	}

	if(maxvaha > 0)
	{
		DribbleTo2(pos,bestdir);
		//DBGN("%f",bestdir);
		return true;
	}
	return false;
}

// Rozohranie lopty spoluhracov zo zahravacich modov
bool PlayerTactics::StartPlayOnByPassToOurPlayer()
{
	// Rozohram vhodne postavenemu hracovi
			
	double fTmpX, fTmpY;
				
	Point myPosition = world->me->pos;
	if(ePlayerList->CalculateNormalPassPosition(myPosition.GetX(), myPosition.GetY(), fTmpX, fTmpY))
	{
		Point passPosition(fTmpX, fTmpY);
		DBGN("Prihravka na (%.3lf, %.3lf)", passPosition.GetX(), passPosition.GetY());

		Vector vectFromMeToPassPoint = passPosition - world->me->pos;
		
		float lfDistance = vectFromMeToPassPoint.GetLength();
		float lfPassSpeed = (lfDistance - lfMinPassDistance) / (lfMaxPassDistance - lfMinPassDistance) * (world->params->server->ball_speed_max - 1.4) +  1.4;

		PassBallTo(passPosition, CorrectPassSpeed(lfPassSpeed));
		return true;
	}
	else
	{
		PassBallTo(Point(45, 0) , CorrectPassSpeed(world->params->server->ball_speed_max));
		return false;
	}
}

// Hrac sa bude snazit neprijat nahravku
bool PlayerTactics::UnblockMyself(Vector* shift)
{
//	UBLK_DBGN("%i: Trying Unblock", world->state->GetSimTime());

	// Presun sa kusok od blokujuceho supera
	if(!world->ball->IsValid()) 
	{
		UBLK_DBGN("%i: ball invalid", world->state->GetSimTime());
		return false;
	}
	
	// Je lopta dostatocne daleko?
	Vector dBall = world->ball->pos - world->me->pos;
	if(dBall.GetLength() < 5.f) 
	{ 
		UBLK_DBGN("%i: ball too near %3.2f", world->state->GetSimTime(), dBall.GetLength());
		return false;
	}

	// Som otoceny tym istym smerom ako lopta?
	Angle delta = (world->me->GetAbsDir() - dBall.GetAngle()).Abs();
	
	if(delta > DegAngle(25)) 
	{
		UBLK_DBGN("%i: bad absdir %3.2f", world->state->GetSimTime(), delta.GetDeg());
		return false;
	}

	// Kde by som sa mal presunut?
	*shift = RectVector(0, 0);
	
	int posCnt = 0;
	int negCnt = 0;

	int i;
	for(i = 0; i < world->enemies.GetSize(); i++)
	{
		Vector dEnemy = world->enemies[i].pos - world->me->pos;
		Angle alpha = (dEnemy.GetAngle() - dBall.GetAngle()).Abs();

		float eLen = (dBall - dEnemy).GetLength();

	    if(eLen < dBall.GetLength() && dEnemy.GetLength() < 2.f && alpha < DegAngle(60))
		{
/*			if(dEnemy.GetAngle() > DegAngle(0)) posCnt++;
			else if(dEnemy.GetAngle() < DegAngle(0)) negCnt++;
			else { posCnt++; negCnt++; }*/

			Vector tmp = PolarVector(5.f/*2.f * dEnemy.GetLength()*/, world->me->GetAbsDir());
			if(tmp.GetLength() > shift->GetLength())
				*shift = tmp;
		
			UBLK_DBGN("%i: Blocked by %i angle %3.2f", world->state->GetSimTime(), world->enemies[i].GetUniform(), alpha.GetDeg());
		}
	}

	if(shift->GetLength() == 0)
		return false;

	if(shift->GetLength() > 5.f)
		shift->SetLength(5.f);
	
	return true;
}

// Inicializovanie taktickeho modulu
void PlayerTactics::OnInit(RealSide realSide, unsigned uniform, PlayMode iMode)	
{
	PlayerSkills::OnInit(realSide, uniform, iMode);

	// inicializacia formacii
	//m_cFormation.InitRawUnits( SIDE_LEFT, PlayerConfig.GetFormation(), PlayerConfig.GetDefUnit(), 
//	PlayerConfig.GetMidUnit(), PlayerConfig.GetForUnit() );
//	m_cFormation.InitRawUnits( SIDE_LEFT, FORMATION_343, UNIT_3_L, UNIT_4_OV, UNIT_3_OV );
//	m_cFormation.InitRawUnits(SIDE_LEFT, -1, 16, 2, 17);
//	m_cFormation.SetUnitOffset(-30.0f);
	FILE *f;
	char def, mid, atk, offset;
	float offset2;

	if ((f = fopen("formation.cfg", "r")) != NULL)
	{
		if (4 != fscanf(f, "%c%c%c%c", &def, &mid, &atk, &offset))
		{
			TXT("Zly format configu formacii, pouzivam default QCRN\n\n");
			m_cFormation.SetUnits(16, 2, 17);
			m_cFormation.SetUnitOffset(-30.0);
			fclose(f);
		}
		else
		{
			TXT("Formacia nacitana: %c%c%c%c\n\n", def, mid, atk, offset);
			m_cFormation.SetUnits(def - 'A', mid - 'A', atk - 'A');
			offset2 = 2.0f*(offset-'A') - FIELDWIDTH/2.0f;
			m_cFormation.SetUnitOffset(offset2);
			fclose(f);
		}
	}
	else
	{
		TXT("Config formacii nenajdeny, pouzivam default QCRN\n\n");
		m_cFormation.SetUnits(16, 2, 17);	
		m_cFormation.SetUnitOffset(-30.0);
	}
}

// Vrati ofsajdovu ciaru.
float PlayerTactics::GetOffsideLine() const
{
	return PlayerSkills::GetOffsideLine();
}

// Vrati hraca, ktory je najvhodnejsie na nahravanie. -1 => ziadny hrac
int PlayerTactics::GetPassAbleFriend()
{
	if (PassTesting)
	{
//		printf("Idem pouzit nasu!\n");
		return FCGetPassAbleFriend();
	}
	
	float myDist = DistanceToGoal(world->me->pos);
	float distFriendGoal;
	Vector diffFriend;
	float distToFriend;

	Vector diffEnemy;
	float distToEnemy;

	int best = -1;

	for(int who = 0;who < world->friends.GetSize(); who++)
	{
		distFriendGoal = DistanceToGoal(world->friends[who].pos);

		// Spohuhrac je blizsie ku brane
		if(distFriendGoal < myDist)
		{
			diffFriend = world->friends[who].pos - world->me->pos;
			distToFriend = diffFriend.GetLength();
			// Spoluhrac nie je dalej ako 30 a nie blizsie ako 3m (30 a 5 su default hodnoty)
			if(distToFriend <= world->variables->GetPassSurroundingsMaxWidth() && 
				distToFriend > world->variables->GetPassSurroundingsMinWidth())
			{
				bool blockingEnemy = false;
				
				for(int e=0; e < world->enemies.GetSize() && !blockingEnemy; e++)
				{
					diffEnemy = world->enemies[e].pos - world->me->pos;
					distToEnemy = diffEnemy.GetLength();
					// potencialne by mohol blokovat
					if(distToEnemy < distToFriend)
					{
						// do 17 stupnov blokuje
						if((diffFriend.GetAngle() - diffEnemy.GetAngle()).GetAbsDeg() < 17)
						{
							blockingEnemy = true;
						}
					}
				}

				if(!blockingEnemy)
				{
					best = who;
					myDist = distFriendGoal; // aby sa nasiel najblizsi
				}
			}
		}
	}

	return best;
}

// Je hrac v ofsajde?
bool PlayerTactics::InOffsidePos()
{
	if (world->me->pos.GetX() <	GetOffsideLine())
		return false;
	
	return true;
}

//=========================================
// Loptosi - mj ===========================

bool PlayerTactics::LPT_GetAmILeader(){
	return LPT_AmILeader;
}

int PlayerTactics::LPT_GetLeaderUniform(){
	return LPT_LeaderUniform;
}


// POSIELANIE SPRAV
// ----------------
// krici veduci kandidatovi
void PlayerTactics::LPT_SendTySiLeaderMSG(int uniformNumber)
{
	char msg[6];
  sprintf(msg, "LTY%d", uniformNumber);

	LPT_LastSendTime = world->state->GetSimTime();

  fprintf(stderr, "[LPT] u%d t%d: Posielam hracovi %d: Bud veduci!\n", world->me->GetUniform(), world->state->GetSimTime(), uniformNumber);
  getCommGen()->AttentionTo(uniformNumber);
	getCommGen()->Say(msg);
}

// krici kandidat ako potvrdenie leaderovi staremu
void PlayerTactics::LPT_SendOkSomLeaderMSG()
{
	getCommGen()->Say("LOK");
}

// krici stary veduci o novom + hraci medzi sebou
void PlayerTactics::LPT_SendLeaderMSG()
{
	char msg[6];

	if (!LPT_AmILeader)
  {
		fprintf(stderr, "[LPT] u%d t%d: Kricim: Hrac %d je veduci.\n", world->me->GetUniform(), world->state->GetSimTime(), LPT_LeaderUniform);
    sprintf(msg, "LJE%d", LPT_LeaderUniform);
  } else
  {
    //tato vetva sa vyvola len v simulacnom case 0
		fprintf(stderr, "[LPT] u%d t%d: Som veduci, posielam info dalej.\n", world->me->GetUniform(), world->state->GetSimTime());
    sprintf(msg, "LJE%d", world->me->GetUniform());
	}

	getCommGen()->Say(msg);
}

// krici leader pri zmene formacie
void PlayerTactics::LPT_SendZmenaFormacieLeaderMSG()
{
	char msg[6];

	fprintf(stderr, "[LPT] u%d t%d: Kricim: Zoradte sa do formacie %d!\n", world->me->GetUniform(), world->state->GetSimTime(), LPT_CurrentFormation);
  sprintf(msg, "LFC%d", (int) LPT_CurrentFormation);
	getCommGen()->Say(msg);
}

// krici leader pri zmene formacie
void PlayerTactics::LPT_SendZmenaFormaciePlayerMSG()
{
	char msg[6];

	fprintf(stderr, "[LPT] u%d t%d: Opakujem prikaz veduceho: Formacia %d\n", world->me->GetUniform(), world->state->GetSimTime(), LPT_CurrentFormation);
  sprintf(msg, "PFC%d", (int) LPT_CurrentFormation);
	getCommGen()->Say(msg);
}

void PlayerTactics::RunPlayOn()
{
  // Ak nikoho nepocuvam, nie som veduci a viem kto je veduci, tak si nastavim nanho AttentionTo
	if (!LPT_AttentionToSet && !LPT_AmILeader)
  {
		if (LPT_LeaderUniform > 0)
    {
			getCommGen()->AttentionTo(LPT_LeaderUniform);
			LPT_AttentionToSet = true;
		}
	}

	if (LPT_AmILeader)
  {
    int simTime = world->state->GetSimTime();

    if (simTime > (LPT_LastChangeTime + 1) && //rezerva 1 cyklus, aby sa vsetci dozvedeli o zmene
        (simTime - LPT_LastSendTime) > 4) //od pokusu o zmenu veduceho ubehli najviac tri cykly
    {
  		if (simTime % 59 == 0)
      {
		  	if (GetNearestFriendDistance(world->me->pos) >= 40)
        {
	        fprintf(stderr, "[LPT] u%d t%d: Som prilis sam. Nejdem sa vzdat vedenia.\n", world->me->GetUniform(), simTime);
  				//sabor RunToPoint(world->friends[GetNearestFriend(world->me->pos)].pos, true);
	  		} else
        {
          LPT_SendTySiLeaderMSG(world->friends[GetNearestFriend(world->me->pos)].GetUniform());
          LPT_LastChangeTime = simTime;
        }
	  	} else
  		if (simTime % 17 == 0)
      {
        //sabor if (GetNearestFriendDistance(world->me->pos) >= 50)
        //sabor   RunToPoint(world->friends[GetNearestFriend(world->me->pos)].pos,true);
        //cyklicka zmena formacie
        if (LPT_CurrentFormation == LPT_FR_LAST)
          LPT_CurrentFormation = LPT_FR_FIRST; else
          LPT_CurrentFormation = (LPT_FormationType) ((int) LPT_CurrentFormation + 1);
			  LPT_SendZmenaFormacieLeaderMSG();
  			LPT_LastChangeTime = simTime;
	  	}
    }
	}

	PlayerSkills::RunPlayOn();
}

void PlayerTactics::RunPlayOff()
{
  //ak este nik nebol veduci a som hrac cislo 5, nastavim sa ako veduci
	if ((!LPT_AmILeader && LPT_LeaderUniform == -1) && (world->me->GetUniform() == 5))
		LPT_AmILeader = true;

  // Ak nikoho nepocuvam a nie som veduci a viem kto je veduci, tak si nastavim nanho attentionto
	if (!LPT_AttentionToSet && !LPT_AmILeader)
  {
		if (LPT_LeaderUniform > 0)
    {
			getCommGen()->AttentionTo(LPT_LeaderUniform);
			LPT_AttentionToSet = true;
		}
	}

  //ak som veduci a zapas este nezacal, oznamujem to ostatnym
	if (LPT_AmILeader && LPT_LastChangeTime == -1 && world->state->GetSimTime() == 0)
  {
    LPT_SendLeaderMSG();
    LPT_LastChangeTime = 0;
  }

	PlayerSkills::RunPlayOff();
}

void PlayerTactics::LPT_processLeaderMSG(int time, int uniform, const char *msg)
{
	if (strcmp(msg, "LOK") == 0)
  {
    if (LPT_AmILeader)
    {
		  if ((time - LPT_LastSendTime) <= 3)
      {
  	    LPT_AmILeader = false;
			  LPT_LeaderUniform = uniform;
        LPT_LastChangeTime = world->state->GetSimTime(); //aby sa v tomto a v najblizsom cykle nesnazil nic kricat
			  fprintf(stderr, "[LPT] u%d t%d: Vzdal som sa vedenia. Novy veduci je %d.\n", world->me->GetUniform(), world->state->GetSimTime(), uniform);
        LPT_SendLeaderMSG();
      }
		}
		return;
	}

  if (strlen(msg) > 3)
  {
			if (strncmp(msg, "LTY", 3) == 0)
      {
				//veduci poslal prikaz, ze mam byt novy veduci; treba mu poslat LOK
				if (atoi(msg+3) == world->me->GetUniform())
        {
					LPT_AmILeader = true;
          LPT_LeaderUniform = world->me->GetUniform();
          LPT_LastChangeTime = world->state->GetSimTime(); //aby sa v tomto a v najblizsom cykle nesnazil nic kricat
					fprintf(stderr, "[LPT] u%d t%d: Prijal som poziadavku, ze mam byt veduci a suhlasim.\n", world->me->GetUniform(), world->state->GetSimTime());
					LPT_SendOkSomLeaderMSG();
          getCommGen()->AttentionOff();
					return;
				}
			} else
      if (strncmp(msg, "LJE", 3) == 0)
      {
				//hrac/veduci poslal oznam, kto je veduci
				if (LPT_LeaderUniform != atoi(msg+3))
        {
				  LPT_LeaderUniform = atoi(msg+3);
					getCommGen()->AttentionTo(LPT_LeaderUniform); //pocuvam veduceho
          LPT_SendLeaderMSG(); //oznamim svetu, kto je veduci
					return;
				}
			}
			else
      if (strncmp(msg, "LFC", 3) == 0)
      {
				//veduci poslal prikaz na zmenu formacie
				int forID;
				forID = atoi(msg+3);
				LPT_CurrentFormation = (LPT_FormationType) forID;
        if (uniform != LPT_LeaderUniform)
        { //mam zlu informaciu o veducom -> upravujem
          LPT_LeaderUniform = uniform;
          getCommGen()->AttentionTo(LPT_LeaderUniform);
        }
				LPT_SendZmenaFormaciePlayerMSG();
			}
			else if (strncmp(msg, "PFC",3) == 0)
      {
				//hrac zopakoval prikaz na zmenu formacie od veduceho
				int forID;
				forID = atoi(msg+3);
        if (LPT_CurrentFormation != (LPT_FormationType) forID)
        {
          LPT_CurrentFormation = (LPT_FormationType) forID;
          fprintf(stderr, "[LPT] u%d t%d: Od hraca %d som zistil, ze sucasna formacia je %d\n", world->me->GetUniform(), world->state->GetSimTime(), uniform, LPT_CurrentFormation);
        }
			}
			else
      {
				// ziadna zaujimava sprava -> /dev/null :P
				return;
			}
	} else
  {
    // ziadna zaujimava sprava -> /dev/null :P
    return;
  }
}

// Pretazena metoda z PlayerKernel
// Spracuje zvukovu informaciu
void PlayerTactics::OnHear(int time, float direction, bool ourTeam, int uniform, const char* msg)
{
	// Ignoruj spravy z druheho timu
	if(!ourTeam)
		return;

	// Spracovanie loptosskych sprav
  if (strlen(msg) >= 3 && (msg[0] == 'L' || msg[0] == 'P'))
  {
    char sprava[100];
    strcpy(sprava, msg);
    sprava[strlen(sprava)-1] = '\0'; //odstranenie zatvorky ')'
		LPT_processLeaderMSG(time, uniform, sprava);
		return;
	}
	// Zisti informacie o odosielatelovi
	Player player(world);
	player.SetUniform(uniform);

	// Parsujeme jeho spravu. Kazdy znak je skonvertovany na cislo z intervalu <0, 71> (ignorujeme '_' a ' ').
	// Cislo je rozdelene do troch casti: 2x 3-stavove a 3x 2-stavove (3*3*2*2*2=72)
	// Pouzivame tri casti a interval <0, 71> cisiel na ulozenie udajov efektivnym sposobom.
	// Pozri aj PlayerSkills:SendInfo()

	unsigned char parts[10][6];
	for(int i = 0; i < 10; i++)
	{
		// Konvertuje do <0, 71>
		unsigned char num;
		if((msg[i] >= 'a') && (msg[i] <= 'z'))
			num = ((char) msg[i]) - 'a';
		else if((msg[i] >= 'A') && (msg[i] <= 'Z'))
			num = ((char) msg[i]) - 'A' + 26;
		else if((msg[i] >= '0') && (msg[i] <= '9'))
			num = ((char) msg[i]) - '0' + 52;
		else if(msg[i] == '+')
			num = 62;
		else if(msg[i] == '-')
			num = 63;
		else if(msg[i] == '*')
			num = 64;
		else if(msg[i] == '/')
			num = 65;
		else if(msg[i] == '(')
			num = 66;
		else if(msg[i] == ')')
			num = 67;
		else if(msg[i] == '.')
			num = 68;
		else if(msg[i] == '?')
			num = 69;
		else if(msg[i] == '<')
			num = 70;
		else if(msg[i] == '>')
			num = 71;
		else
		{
			WARNN("failed decoding for hear (%i->%c)", i, msg[i]);
		return;
		}

		// Rozdelene do casti
		parts[i][0] = num;
		parts[i][1] = num % 3; num /= 3;
		parts[i][2] = num % 3; num /= 3;
		parts[i][3] = num % 2; num /= 2;
		parts[i][4] = num % 2; num /= 2;
		parts[i][5] = num % 2; num /= 2;
	}

	Point* flags = world->params->flags;

/*	DBGN("---");
	for(i = 0; i < 10; i++) DBG("%i ", (int) parts[i][0]); DBGN("");
	for(i = 0; i < 10; i++) DBG("%i ", (int) parts[i][1]); DBGN("");
	for(i = 0; i < 10; i++) DBG("%i ", (int) parts[i][2]); DBGN("");
	for(i = 0; i < 10; i++) DBG("%i ", (int) parts[i][3]); DBGN("");
	for(i = 0; i < 10; i++) DBG("%i ", (int) parts[i][4]); DBGN("");
	for(i = 0; i < 10; i++) DBG("%i ", (int) parts[i][5]); DBGN("");
*/

	// Alokacia casti:
	// - = volne, X = hracova x-ova suradnica, Y = hracova y-ova suradnica
	// D = hracov smer, S = hracova rychlost
	// 1(3) XYDS----YY
	// 2(3) XYDS----DX
	// 3(2) XYDS----DX
	// 4(2) XYDS----SX
	// 5(2) XYDS----YX
	// This has to be the same as in SendInfo().

	// X suradnica hraca (pouziva sa 72,3,2,2,2 pozri hore)
	int tmp = (((parts[0][0] * 3 + parts[9][2]) * 2 + parts[9][3]) * 2 + parts[9][4]) * 2 + parts[9][5];
//	DBGN("tmp_x %i", tmp);
	player.pos.SetX(float(tmp) * (flags[R0].GetX() - flags[L0].GetX()) / 
		float(72 * 3 * 2 * 2 * 2) + flags[L0].GetX());

	// Y suradnica hraca (pouziva sa 72,3,3,2 pozri hore)
	tmp = ((parts[1][0] * 3 + parts[9][1]) * 3 + parts[8][1]) * 2 + parts[8][5];
//	DBGN("tmp_y %i", tmp);
	player.pos.SetY(float(tmp) * (flags[B0].GetY() - flags[T0].GetY()) / 
		float(72 * 3 * 3 * 2) + flags[T0].GetY());

	// Smer hraca (pouziva sa 72,3,2 pozri hore)
	tmp = (parts[2][0] * 3 + parts[8][2]) * 2 + parts[8][3];
	float dir = float(tmp) * 2.0f * M_PI / float(72 * 3 * 2);
//	DBGN("tmp_dir %i ang %0.3f", tmp, dir);

	// Rychlost hraca (pouziva sa 72,2 pozri hore)
	tmp = parts[3][0] * 2 + parts[8][4];
//	DBGN("tmp_spd %i", tmp);
	float spd = float(tmp) * (world->params->server->player_speed_max + world->params->player->player_speed_max_delta_max) / float(72 * 2);

	player.vel.SetX(float(spd * cos(dir)));
	player.vel.SetY(float(spd * sin(dir)));
	player.SetAge(MAX_PLAYER_AGE - 10);

	// Uloz informaciu o odosielatelovi
	int index = world->FindFriendIndex(player.GetUniform());
	
	if(index == -1)
		world->friends.Add(player);
	else
		world->friends[index] = player;

	SHOUT_DBGN("SHT %i: RECV INFO: %i: %0.2f, %0.2f, %0.2f, %0.2f", world->state->GetSimTime(), player.GetUniform(), player.pos.GetX(), player.pos.GetY(), player.vel.GetX(), player.vel.GetY());
	if(index == -1) SHOUT_DBGN("SHT %i: Hmmm, new player", world->state->GetSimTime());

//	&other_ball.pos.GetX(), &other_ball.pos.GetY(), &other_ball.vel.GetX(), &other_ball.vel.GetY(), &other_ball.age,

/*	if(ball.valid) //viem o lopte, takze mozem upravit poziciu
	{
		float mydist = (world->ball->pos - world->me->pos).GetLength();
		float hisdist = (other_ball.pos - other_player.pos).GetLength();

		if(hisdist < mydist && other_ball.age < ball.age) //podmienka aktualizacie
		{
			ball = other_ball;
			ball.valid = true;
		}
	}*/
}

//Loptosi - mj ====================================

// ------- FC_Farmari -------------------------------------------------------------------------------------------	    

int PlayerTactics::FCGetPassAbleFriend()
{
	float myDist = DistanceToGoal(world->me->pos);
	float distFriendGoal;
	Vector diffFriend;
	float distToFriend;

	Vector diffEnemy;

	double	*Res = new double[3], max;
	double	Res2[3*16];
	// Ak mi siet vrati 1 -> ze enenmy neohrozuje ak vrati 0 -> ohrozuje
	// Cize budem hladat najvacsie cislo;
	double	BestRes = 0.0, NetRes, r = 0.0;
	
	int best = 465, j;

	for(int who = 0;who < world->friends.GetSize(); who++) {
		distFriendGoal = DistanceToGoal(world->friends[who].pos);

		// spohuhrac je blizsie ku brane
		if(distFriendGoal < myDist) {
			diffFriend = world->friends[who].pos - world->me->pos;
			distToFriend = diffFriend.GetLength();
			// spoluhrac nie je dalej ako 30 a nie blizsie ako 3m (30 a 5 su default hodnoty)
			if(
				distToFriend <= world->variables->GetPassSurroundingsMaxWidth() && 
				distToFriend > world->variables->GetPassSurroundingsMinWidth())
			{
				bool blockingEnemy = false;
				NetRes = 1.2;
				for(int e=0; e < world->enemies.GetSize(); e++)
				{
					//diffEnemy = world->enemies[e].pos - world->me->pos;
					//distToEnemy = diffEnemy.GetLength();
					if(!e)
						NetRes = 1.0;

					if (((PlayerSkills*)this)->FCBelongsToArea(world->me->pos, world->friends[who].pos, world->enemies[e].pos))
					{
						((PlayerSkills*)this)->FCGetDistances(world->me->pos, world->friends[who].pos, world->enemies[e].pos, Res) ;
						// dam na vstup sieti Res
						max = Res[0];
						for (j = 0; j < 3; j++)
							if (Res[j] > max)
								max = Res[j];

						for (j = 0; j < 3; j++)
						{
							Res[j] /= max;
							if (Res[j] > 0.9999999999999)
							Res[j] = 0.9999999999999;
						}
						
						RealToBin(Res[0], &Res2[0]);
						RealToBin(Res[1], &Res2[16]);
						RealToBin(Res[2], &Res2[32]);
						m_PassNet->SetInput(Res2, 0);
						r = m_PassNet->GetOutput(0);
						//if (r < NetRes)
						//	NetRes = r;
						NetRes *= r;

						printf("Nepriatel: %d, Ohodnoteny: %lf Vstupy(%lf, %lf, %lf)\n", e, r, Res[0], Res[1], Res[2]);
						
					}
				}

				if((NetRes > BestRes) && (NetRes < 1.1))
				{
					best = who;
					BestRes = NetRes;
				}
			}
		}
	}

	delete Res;

	printf("Ohodnotenie: %lf\n", BestRes);
	//if (BestRes < 0.1)
	//	return -1;
	//else
	if(best != 465)
		return best;
	else 
		return -1;
}

void PlayerTactics::RealToBin(double num, double* buff)
{
	double decright = num;	// oddeluj pravu a lavu stranu desatineho cisla

	// skonvertuj lavu stranu na binarnu hodnotu

	int  j=0;
    double track;
  
	// skonvertuj pravu stranu na binarnu hodnotu
	do
	{
		track = decright*2;
		
		if ( (track-1)<0 )
		{
			decright = track;
			buff[j++] = 0.0;
		}

		else
		{
			decright = track-1;
			buff[j++] = 1.0;
		}
	} while ((decright < 1) && (j < 16));

	//binright[j] = 0;
	//printf("\n binary of right is %s \n", binright);

}

// --------------------------------------------------------------------------------------------------------------










	
	
